local hcTk = HCToolkit

local SendChatMessage = SendChatMessage
local UnitIsGroupLeader = UnitIsGroupLeader

local giftOfTheSeaId = 258647 -- Haste / Vers
local giftOfTheSkyId = 258646 -- Crit / Mastery
local sargerasFearId = 257931
local sargerasRageId = 257896
local soulblightId = 248396
local soulbombId = 251570
local soulburstId = 250669

function hcTk.ArgusEncounterStart()
    hcTk.Encounter["Combos"] = {}
    hcTk.Encounter["GiftOfTheSeas"] = {}
    hcTk.Encounter["GiftOfTheSkys"] = {}
    hcTk.Encounter["SargerasFears"] = {}
    hcTk.Encounter["SargerasRages"] = {}
    hcTk.Encounter["Soulblights"] = {}
    hcTk.Encounter["Soulbursts"] = {}
    hcTk.Encounter["Soulbombs"] = {}

    if hcTk.ArgusIsDisplayCombosEnabled() then
        HCToolkitGroupFrame:SetScript("OnUpdate", hcTk.ArgusDisplayCombos)
    end
end

function hcTk.ArgusEncounterEnd()
    hcTk.Encounter["Combos"] = nil
    hcTk.Encounter["GiftOfTheSeas"] = nil
    hcTk.Encounter["GiftOfTheSkys"] = nil
    hcTk.Encounter["SargerasFears"] = nil
    hcTk.Encounter["SargerasRages"] = nil
    hcTk.Encounter["Soulblights"] = nil
    hcTk.Encounter["Soulbursts"] = nil
    hcTk.Encounter["Soulbombs"] = nil
end

function hcTk.ArgusCombatLog(...)
    local msg = select(2, ...)
    if (hcTk.ArgusCombatLogFns[msg] ~= nil) then
        hcTk.ArgusCombatLogFns[msg](...)
    end
end

function hcTk.ArgusSpellAuraApplied(...)
    local destGUID, _, _, _, spellId = select(8, ...)
    if (hcTk.Group[destGUID] ~= nil and (spellId == sargerasFearId 
            or spellId == sargerasRageId 
            or spellId == soulblightId 
            or spellId == soulbombId 
            or spellId == soulburstId)) then

        if (spellId == soulblightId) then -- Soulblight
            hcTk.Encounter["Soulblights"][destGUID] = GetTime() + 8
            if (hcTk.ArgusIsEmitSoulblightText() and hcTk.PlayerGUID == destGUID) then
                SendChatMessage("Soulblight On Me!", "SAY")
                C_Timer.After(5, function() SendChatMessage("Soulblight Dropping In 3", "SAY") end)
                C_Timer.After(6, function() SendChatMessage("Soulblight Dropping In 2", "SAY") end)
                C_Timer.After(7, function() SendChatMessage("Soulblight Dropping In 1", "SAY") end)
            end
        elseif (spellId == soulburstId) then -- Soulburst
            hcTk.Encounter["Soulbursts"][destGUID] = GetTime() + 12
        elseif (spellId == soulbombId) then -- Soulbomb
            hcTk.Encounter["Soulbombs"][destGUID] = GetTime() + 12
        elseif (spellId == sargerasRageId) then -- Sargeras' Rage
            hcTk.Encounter["SargerasRages"][destGUID] = GetTime() + 30
        elseif (spellId == sargerasFearId) then -- Sargeras' Fear
            hcTk.Encounter["SargerasFears"][destGUID] = GetTime() + 30
        end

        hcTk.ArgusBuildCombos()

        if (hcTk.ArgusIsEmitEscortText() and destGUID == hcTk.PlayerGUID and hcTk.Encounter["Combos"][destGUID] ~= nil) then
            SendChatMessage("ESCORT ME!!!", "YELL")
        end
    end

    if (hcTk.Group[destGUID] ~= nil and spellId == giftOfTheSeaId) then -- Gift Of The Sea
        hcTk.Encounter["GiftOfTheSeas"][destGUID] = GetTime() + 5
        if (hcTk.PlayerGUID == destGUID) then
            if (hcTk.ArgusIsDisplaySkySeaPersonalEnabled()) then
                hcTk.FrameUpdateText(HCToolkitPersonalFrame, string.format("%s", "Haste / Vers! ! Drop Right --->"))
            end

            if (hcTk.ArgusIsEmitSkySeaText()) then
                SendChatMessage(string.format("%s", "Haste / Vers! ! Drop Right --->"), "SAY")
            end
        end
    elseif (hcTk.Group[destGUID] ~= nil and spellId == giftOfTheSkyId) then -- Gift Of The Sky
        hcTk.Encounter["GiftOfTheSkys"][destGUID] = GetTime() + 5
        if (hcTk.PlayerGUID == destGUID) then
            if (hcTk.ArgusIsDisplaySkySeaPersonalEnabled()) then
                hcTk.FrameUpdateText(HCToolkitPersonalFrame, string.format("%s", "Drop Left <--- ! Crit / Mastery!"))
            end

            if (hcTk.ArgusIsEmitSkySeaText()) then
                SendChatMessage(string.format("%s", "Drop Left <--- ! Crit / Mastery!", "SAY"))
            end
        end
    end
end

function hcTk.ArgusSpellAuraRemoved(...)
    local destGUID, _, _, _, spellId = select(8, ...)
    if (hcTk.Group[destGUID] ~= nil and (spellId == sargerasFearId 
            or spellId == sargerasRageId 
            or spellId == soulblightId 
            or spellId == soulbombId 
            or spellId == soulburstId)) then
        if (spellId == sargerasFearId) then
            hcTk.ArgusRemoveDebuffFromTable("SargerasFears", destGUID)
        elseif (spellId == sargerasRageId) then
            hcTk.ArgusRemoveDebuffFromTable("SargerasRages", destGUID)
        elseif (spellId == soulblightId) then
            hcTk.ArgusRemoveDebuffFromTable("Soulblights", destGUID)
        elseif (spellId == soulbombId) then
            hcTk.ArgusRemoveDebuffFromTable("Soulbombs", destGUID)
        elseif (spellId == soulburstId) then
            hcTk.ArgusRemoveDebuffFromTable("Soulbursts", destGUID)
        end

        hcTk.ArgusBuildCombos()
    elseif (hcTk.Group[destGUID]  ~= nil and (spellId == giftOfTheSeaId) and destGUID == hcTk.PlayerGUID) then
        hcTk.ArgusRemoveDebuffFromTable("GiftOfTheSeas", destGUID)
        hcTk.FrameUpdateText(HCToolkitPersonalFrame, "")
    elseif (hcTk.Group[destGUID]  ~= nil and (spellId == giftOfTheSkyId) and destGUID == hcTk.PlayerGUID) then
        hcTk.ArgusRemoveDebuffFromTable("GiftOfTheSkys", destGUID)
        hcTk.FrameUpdateText(HCToolkitPersonalFrame, "")
    end
end

function hcTk.ArgusUnitDied(...)
    local destGUID = select(8, ...)
    if (hcTk.Group[destGUID] ~= nil) then
        hcTk.ArgusRemoveDebuffFromTable("GiftOfTheSeas", destGUID)
        hcTk.ArgusRemoveDebuffFromTable("GiftOfTheSkys", destGUID)
        hcTk.ArgusRemoveDebuffFromTable("Soulblights", destGUID)
        hcTk.ArgusRemoveDebuffFromTable("Soulbursts", destGUID)
        hcTk.ArgusRemoveDebuffFromTable("Soulbombs", destGUID)
        hcTk.ArgusRemoveDebuffFromTable("SargerasRages", destGUID)
        hcTk.ArgusRemoveDebuffFromTable("SargerasFears", destGUID)

        if (hcTk.PlayerGUID == destGUID) then
            hcTk.FrameUpdateText(HCToolkitPersonalFrame, "")
        end

        hcTk.ArgusBuildCombos()
    end
end

function hcTk.ArgusBuildCombos()
    local combos = {}
    for guid, v in pairs(hcTk.Encounter["SargerasFears"]) do
        if (hcTk.Encounter["Soulblights"][guid] ~= nil 
            or hcTk.Encounter["Soulbursts"][guid] ~= nil 
            or hcTk.Encounter["Soulbombs"][guid] ~= nil) then
                combos[#combos + 1] = guid
        end
    end
    hcTk.Encounter["Combos"] = combos
end

function hcTk.ArgusRemoveDebuffFromTable(tableName, guid)
    if (hcTk.Encounter[tableName] ~= nil) then
        hcTk.Encounter[tableName][guid] = nil
    end
end

function hcTk.ArgusDisplayCombos()
    local players = {}

    for k, guid in ipairs(hcTk.Encounter["Combos"]) do
        players[#players + 1] = hcTk.UnitPlayerString(hcTk.Group[guid])
    end

    hcTk.FrameUpdateText(HCToolkitGroupFrame, table.concat(players, "\n"))
end

function hcTk.ArgusIsDisplayCombosEnabled()
    return hcTk.GenericGetBossOption("Antorus", "Argus", "DisplayCombosGroup")
end

function hcTk.ArgusIsDisplaySkySeaPersonalEnabled()
    return hcTk.GenericGetBossOption("Antorus", "Argus", "DisplaySkySeaPersonal")
end

function hcTk.ArgusIsEmitEscortText()
    return hcTk.GenericGetBossOption("Antorus", "Argus", "EmitEscortText")
end

function hcTk.ArgusIsEmitSkySeaText()
    return hcTk.GenericGetBossOption("Antorus", "Argus", "EmitSkySeaText")
end

function hcTk.ArgusIsEmitSoulblightText()
    return hcTk.GenericGetBossOption("Antorus", "Argus", "EmitSoulblightText")
end

hcTk.ArgusCombatLogFns = {
    ["SPELL_AURA_APPLIED"] = hcTk.ArgusSpellAuraApplied,
    ["SPELL_AURA_REMOVED"] = hcTk.ArgusSpellAuraRemoved,
    ["UNIT_DIED"] = hcTk.ArgusUnitDied
}